Summary:	letsencrypt/acme client implemented as a shell-script
Name:		dehydrated
Version:	0.7.0
Release:	2
License:	MIT
Group:		Applications/Networking
Source0:	https://github.com/lukas2511/dehydrated/archive/v%{version}/%{name}-%{version}.tar.gz
# Source0-md5:	a23c9f7a475b9d690e788ee13dd8f14a
Source1:	apache.conf
Source2:	lighttpd.conf
Source3:	nginx.conf
Source5:	hook.sh
Source6:	hook-dns-01.sh
Source7:	crontab
Source8:	sudoers
Patch0:		pld.patch
URL:		https://dehydrated.io/
BuildRequires:	rpmbuild(macros) >= 1.713
Requires:	ca-certificates
Requires:	crondaemon
Requires:	curl
Requires:	diffutils
Requires:	grep
Requires:	mktemp
Requires:	openssl-tools
Requires:	sed
Requires:	sudo
Requires:	webapps
Requires(postun):	/usr/sbin/groupdel
Requires(pre):	/usr/bin/getgid
Requires(pre):	/usr/sbin/groupadd
Suggests:	webserver(access)
Suggests:	webserver(alias)
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_webapps	/etc/webapps
%define		_webapp		%{name}
%define		_sysconfdir	%{_webapps}/%{_webapp}
%define		_appdir		%{_datadir}/%{_webapp}

%description
This is a client for signing certificates with an ACME-server
(currently only provided by letsencrypt) implemented as a relatively
simple bash-script.

Current features:
- Signing of a list of domains
- Signing of a CSR
- Renewal if a certificate is about to expire or SAN (subdomains)
  changed
- Certificate revocation

%prep
%setup -q
%patch0 -p1

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_sbindir},%{_sysconfdir}/certs,/etc/{cron,sudoers}.d} \
	$RPM_BUILD_ROOT/var/lib/%{name}/{accounts,acme-challenge,certs}

install -p %{name} $RPM_BUILD_ROOT%{_sbindir}
cp -p %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/apache.conf
cp -p %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}/lighttpd.conf
cp -p %{SOURCE3} $RPM_BUILD_ROOT%{_sysconfdir}/nginx.conf
cp -p docs/examples/config $RPM_BUILD_ROOT%{_sysconfdir}
cp -p docs/examples/domains.txt $RPM_BUILD_ROOT%{_sysconfdir}
cp -p %{SOURCE7} $RPM_BUILD_ROOT/etc/cron.d/%{name}
cp -p %{SOURCE8} $RPM_BUILD_ROOT/etc/sudoers.d/%{name}
install -p %{SOURCE5} $RPM_BUILD_ROOT%{_sysconfdir}
install -p %{SOURCE6} $RPM_BUILD_ROOT%{_sysconfdir}
cp -p $RPM_BUILD_ROOT%{_sysconfdir}/{apache,httpd}.conf

%pre
%groupadd -g 184 dehydrated

%postun
if [ "$1" = "0" ]; then
	%groupremove dehydrated
fi

%clean
rm -rf $RPM_BUILD_ROOT

%triggerin -- apache1 < 1.3.37-3, apache1-base
%webapp_register apache %{_webapp}

%triggerun -- apache1 < 1.3.37-3, apache1-base
%webapp_unregister apache %{_webapp}

%triggerin -- apache < 2.2.0, apache-base
%webapp_register httpd %{_webapp}

%triggerun -- apache < 2.2.0, apache-base
%webapp_unregister httpd %{_webapp}

%triggerin -- lighttpd
%webapp_register lighttpd %{_webapp}

%triggerun -- lighttpd
%webapp_unregister lighttpd %{_webapp}

%triggerin -- nginx
%webapp_register nginx %{_webapp}

%triggerun -- nginx
%webapp_unregister nginx %{_webapp}

%files
%defattr(644,root,root,755)
%doc README.md CHANGELOG LICENSE
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/cron.d/%{name}
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/sudoers.d/%{name}
%dir %attr(750,root,http) %{_sysconfdir}
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/apache.conf
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/httpd.conf
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/lighttpd.conf
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/nginx.conf
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/config
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/domains.txt
%attr(750,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/hook.sh
%attr(750,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/hook-dns-01.sh
%attr(755,root,root) %{_sbindir}/%{name}
%dir %attr(751,root,root) /var/lib/%{name}
%dir %attr(700,root,root) /var/lib/%{name}/accounts
%dir %attr(750,root,dehydrated) /var/lib/%{name}/certs
# challenges written here, need to be readable by webserver
%dir %attr(751,root,dehydrated) /var/lib/%{name}/acme-challenge
%changelog
* Thu Apr 01 2021 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/dehydrated.git;a=log;h=master

* Thu Apr 01 2021 Jan Rękorajski <baggins@pld-linux.org> fca25a7
- release 2 (by relup.sh)

* Thu Apr 01 2021 Jan Rękorajski <baggins@pld-linux.org> 8f6d073
- rediff patch

* Thu Jan 21 2021 Arkadiusz Miśkiewicz <arekm@maven.pl> c437929
- revert obsoletes (note: letsencrypt.sh package doesn't work anymore)

* Thu Jan 21 2021 Arkadiusz Miśkiewicz <arekm@maven.pl> f8aa239
- up to 0.7.0

* Wed Jan 15 2020 Arkadiusz Miśkiewicz <arekm@maven.pl> 414a1fa
- rel 3; O: letsencrypt.sh (old name of this project)

* Sat Oct 26 2019 Jan Rękorajski <baggins@pld-linux.org> c8b3876
- release 2 (by relup.sh)

* Tue Oct 08 2019 Arkadiusz Miśkiewicz <arekm@maven.pl> 06072c4
- up to 0.6.5

* Mon Dec 31 2018 Elan Ruusamäe <glen@pld-linux.org> deb84dd
- remove set -u

* Wed Dec 19 2018 Marcin Krol <hawk@tld-linux.org> b21cd0a
- fix user/group order in files

* Wed Dec 19 2018 Marcin Krol <hawk@tld-linux.org> e91f323
- run always via sudo as root:dehydrated to allow dehydrated group
  to read certificates and keys, this is useful for services which
  are not running as root but use SSL certificates (ie. ejabberd)

* Fri Dec 07 2018 Elan Ruusamäe <glen@pld-linux.org> 6c47406
- update hooks from upstream examples

* Fri Dec 07 2018 Elan Ruusamäe <glen@pld-linux.org> cf01ce1
- up to 0.6.2; use upstream domains.txt

* Fri Dec 07 2018 Elan Ruusamäe <glen@pld-linux.org> 30b951d
- hook: implement certs copy for apache hook

* Fri Dec 07 2018 Elan Ruusamäe <glen@pld-linux.org> 3870bab
- hook-dns-01.sh: sync with http hook

* Fri Dec 07 2018 Elan Ruusamäe <glen@pld-linux.org> f60f554
- add hook-dns-01.sh

* Tue Mar 20 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 9792a66
- up to 0.6.1

* Mon Mar 27 2017 Elan Ruusamäe <glen@delfi.ee> fb8cccd
- up to 0.4.0

* Tue Jan 03 2017 Elan Ruusamäe <glen@delfi.ee> 623687d
- hook: move each webserver logic to function; use atomic concat to avoid mitm problems

* Mon Jan 02 2017 Elan Ruusamäe <glen@delfi.ee> f85acc7
- release 2 (by relup.sh)

* Mon Jan 02 2017 Elan Ruusamäe <glen@delfi.ee> 69865db
- hook: detect haproxy

